# coding: utf-8

"""
    Gigs Core API

    API to manage voice & data plans for smartphones, wearables and IoT in 200+ countries.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@gigs.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Optional
from pydantic import BaseModel, Field

class DevicesUpdateRequest(BaseModel):
    """
    DevicesUpdateRequest
    """
    name: Optional[Any] = Field(None, description="An optional custom name for the device.")
    sims: Optional[Any] = Field(None, description="List of identifiers for all SIMs currently attached to the device.")
    user: Optional[Any] = Field(None, description="Unique user identifier for the device owner.")
    __properties = ["name", "sims", "user"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DevicesUpdateRequest:
        """Create an instance of DevicesUpdateRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if name (nullable) is None
        # and __fields_set__ contains the field
        if self.name is None and "name" in self.__fields_set__:
            _dict['name'] = None

        # set to None if sims (nullable) is None
        # and __fields_set__ contains the field
        if self.sims is None and "sims" in self.__fields_set__:
            _dict['sims'] = None

        # set to None if user (nullable) is None
        # and __fields_set__ contains the field
        if self.user is None and "user" in self.__fields_set__:
            _dict['user'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DevicesUpdateRequest:
        """Create an instance of DevicesUpdateRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DevicesUpdateRequest.parse_obj(obj)

        _obj = DevicesUpdateRequest.parse_obj({
            "name": obj.get("name"),
            "sims": obj.get("sims"),
            "user": obj.get("user")
        })
        return _obj

