# coding: utf-8

"""
    Gigs Core API

    API to manage voice & data plans for smartphones, wearables and IoT in 200+ countries.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@gigs.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Optional
from pydantic import BaseModel, Field

class Error(BaseModel):
    """
    Error
    """
    object: Optional[Any] = Field(..., description="Type of object is always `error`.")
    code: Optional[Any] = Field(None, description="A machine-readable description of the error.")
    details: Optional[Any] = Field(None, description="Optional array containing specific information for the current error.  <!-- theme: info --> > #### Preview > > This property is currently in preview and might change in the future. > We’re excited to hear your feedback and ideas. Please send an email > to [support@gigs.com](mailto:support@gigs.com) to share your thoughts. ")
    documentation: Optional[Any] = Field(None, description="An optional list of URLs providing further information to resolve the error.")
    hint: Optional[Any] = Field(None, description="An optional explanation how to resolve the error.")
    message: Optional[Any] = Field(..., description="A human readable description of the error.")
    type: Optional[Any] = Field(..., description="The type of [error](https://developers.gigs.com/docs/api/ZG9jOjExMTYzMDU0-error-handling) returned.")
    __properties = ["object", "code", "details", "documentation", "hint", "message", "type"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Error:
        """Create an instance of Error from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if object (nullable) is None
        # and __fields_set__ contains the field
        if self.object is None and "object" in self.__fields_set__:
            _dict['object'] = None

        # set to None if code (nullable) is None
        # and __fields_set__ contains the field
        if self.code is None and "code" in self.__fields_set__:
            _dict['code'] = None

        # set to None if details (nullable) is None
        # and __fields_set__ contains the field
        if self.details is None and "details" in self.__fields_set__:
            _dict['details'] = None

        # set to None if documentation (nullable) is None
        # and __fields_set__ contains the field
        if self.documentation is None and "documentation" in self.__fields_set__:
            _dict['documentation'] = None

        # set to None if hint (nullable) is None
        # and __fields_set__ contains the field
        if self.hint is None and "hint" in self.__fields_set__:
            _dict['hint'] = None

        # set to None if message (nullable) is None
        # and __fields_set__ contains the field
        if self.message is None and "message" in self.__fields_set__:
            _dict['message'] = None

        # set to None if type (nullable) is None
        # and __fields_set__ contains the field
        if self.type is None and "type" in self.__fields_set__:
            _dict['type'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Error:
        """Create an instance of Error from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Error.parse_obj(obj)

        _obj = Error.parse_obj({
            "object": obj.get("object"),
            "code": obj.get("code"),
            "details": obj.get("details"),
            "documentation": obj.get("documentation"),
            "hint": obj.get("hint"),
            "message": obj.get("message"),
            "type": obj.get("type")
        })
        return _obj

