# coding: utf-8

"""
    Gigs Core API

    API to manage voice & data plans for smartphones, wearables and IoT in 200+ countries.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@gigs.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Optional
from pydantic import BaseModel, Field

class PortingDonorProvider(BaseModel):
    """
    The service provider from whom the number is ported.
    """
    object: Optional[Any] = Field(..., description="Type of object is always `serviceProvider`.")
    id: Optional[Any] = Field(..., description="Unique identifier for the service provider.")
    name: Optional[Any] = Field(..., description="The name of the service provider, usually a brand name.")
    recipient_providers: Optional[Any] = Field(..., alias="recipientProviders", description="List of network providers IDs that can receive portings from the service provider.")
    __properties = ["object", "id", "name", "recipientProviders"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PortingDonorProvider:
        """Create an instance of PortingDonorProvider from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if object (nullable) is None
        # and __fields_set__ contains the field
        if self.object is None and "object" in self.__fields_set__:
            _dict['object'] = None

        # set to None if id (nullable) is None
        # and __fields_set__ contains the field
        if self.id is None and "id" in self.__fields_set__:
            _dict['id'] = None

        # set to None if name (nullable) is None
        # and __fields_set__ contains the field
        if self.name is None and "name" in self.__fields_set__:
            _dict['name'] = None

        # set to None if recipient_providers (nullable) is None
        # and __fields_set__ contains the field
        if self.recipient_providers is None and "recipient_providers" in self.__fields_set__:
            _dict['recipientProviders'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PortingDonorProvider:
        """Create an instance of PortingDonorProvider from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PortingDonorProvider.parse_obj(obj)

        _obj = PortingDonorProvider.parse_obj({
            "object": obj.get("object"),
            "id": obj.get("id"),
            "name": obj.get("name"),
            "recipient_providers": obj.get("recipientProviders")
        })
        return _obj

