# coding: utf-8

"""
    Gigs Core API

    API to manage voice & data plans for smartphones, wearables and IoT in 200+ countries.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@gigs.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Optional
from pydantic import BaseModel, Field

class ProjectSupport(BaseModel):
    """
    Contact details for consumer support requests regarding the project.
    """
    email: Optional[Any] = Field(..., description="A publicly available email address for consumer support requests regarding the project.")
    phone_number: Optional[Any] = Field(..., alias="phoneNumber", description="A publicly available phone number in E.164 format for consumer support requests regarding the project.")
    __properties = ["email", "phoneNumber"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ProjectSupport:
        """Create an instance of ProjectSupport from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if email (nullable) is None
        # and __fields_set__ contains the field
        if self.email is None and "email" in self.__fields_set__:
            _dict['email'] = None

        # set to None if phone_number (nullable) is None
        # and __fields_set__ contains the field
        if self.phone_number is None and "phone_number" in self.__fields_set__:
            _dict['phoneNumber'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ProjectSupport:
        """Create an instance of ProjectSupport from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ProjectSupport.parse_obj(obj)

        _obj = ProjectSupport.parse_obj({
            "email": obj.get("email"),
            "phone_number": obj.get("phoneNumber")
        })
        return _obj

