# coding: utf-8

"""
    Gigs Core API

    API to manage voice & data plans for smartphones, wearables and IoT in 200+ countries.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@gigs.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Optional
from pydantic import BaseModel, Field, validator
from gigs_client.models.plan import Plan
from gigs_client.models.subscription_current_period import SubscriptionCurrentPeriod
from gigs_client.models.subscription_porting import SubscriptionPorting
from gigs_client.models.subscription_sim import SubscriptionSim
from gigs_client.models.user import User

class Subscription(BaseModel):
    """
    Subscription
    """
    object: Optional[Any] = Field(..., description="Type of object is always `subscription`.")
    id: Optional[Any] = Field(..., description="Unique identifier for the subscription.")
    current_period: SubscriptionCurrentPeriod = Field(..., alias="currentPeriod")
    phone_number: Optional[Any] = Field(..., alias="phoneNumber", description="The phone number attached to the SIM in E.164 format. Only available for voice plans.")
    plan: Plan = Field(...)
    porting: SubscriptionPorting = Field(...)
    sim: SubscriptionSim = Field(...)
    status: Optional[Any] = Field(..., description="The current status of the subscription.")
    user: User = Field(...)
    activated_at: Optional[Any] = Field(..., alias="activatedAt", description="Time when the subscription was activated.")
    canceled_at: Optional[Any] = Field(..., alias="canceledAt", description="Time when the subscription was canceled.")
    created_at: Optional[Any] = Field(..., alias="createdAt", description="Time when the subscription was created.")
    ended_at: Optional[Any] = Field(..., alias="endedAt", description="Time when the subscription was ended.")
    first_usage_at: Optional[Any] = Field(..., alias="firstUsageAt", description="Time when the subscription was first used.")
    __properties = ["object", "id", "currentPeriod", "phoneNumber", "plan", "porting", "sim", "status", "user", "activatedAt", "canceledAt", "createdAt", "endedAt", "firstUsageAt"]

    @validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('pending', 'active', 'ended'):
            raise ValueError("must be one of enum values ('pending', 'active', 'ended')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Subscription:
        """Create an instance of Subscription from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of current_period
        if self.current_period:
            _dict['currentPeriod'] = self.current_period.to_dict()
        # override the default output from pydantic by calling `to_dict()` of plan
        if self.plan:
            _dict['plan'] = self.plan.to_dict()
        # override the default output from pydantic by calling `to_dict()` of porting
        if self.porting:
            _dict['porting'] = self.porting.to_dict()
        # override the default output from pydantic by calling `to_dict()` of sim
        if self.sim:
            _dict['sim'] = self.sim.to_dict()
        # override the default output from pydantic by calling `to_dict()` of user
        if self.user:
            _dict['user'] = self.user.to_dict()
        # set to None if object (nullable) is None
        # and __fields_set__ contains the field
        if self.object is None and "object" in self.__fields_set__:
            _dict['object'] = None

        # set to None if id (nullable) is None
        # and __fields_set__ contains the field
        if self.id is None and "id" in self.__fields_set__:
            _dict['id'] = None

        # set to None if phone_number (nullable) is None
        # and __fields_set__ contains the field
        if self.phone_number is None and "phone_number" in self.__fields_set__:
            _dict['phoneNumber'] = None

        # set to None if status (nullable) is None
        # and __fields_set__ contains the field
        if self.status is None and "status" in self.__fields_set__:
            _dict['status'] = None

        # set to None if activated_at (nullable) is None
        # and __fields_set__ contains the field
        if self.activated_at is None and "activated_at" in self.__fields_set__:
            _dict['activatedAt'] = None

        # set to None if canceled_at (nullable) is None
        # and __fields_set__ contains the field
        if self.canceled_at is None and "canceled_at" in self.__fields_set__:
            _dict['canceledAt'] = None

        # set to None if created_at (nullable) is None
        # and __fields_set__ contains the field
        if self.created_at is None and "created_at" in self.__fields_set__:
            _dict['createdAt'] = None

        # set to None if ended_at (nullable) is None
        # and __fields_set__ contains the field
        if self.ended_at is None and "ended_at" in self.__fields_set__:
            _dict['endedAt'] = None

        # set to None if first_usage_at (nullable) is None
        # and __fields_set__ contains the field
        if self.first_usage_at is None and "first_usage_at" in self.__fields_set__:
            _dict['firstUsageAt'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Subscription:
        """Create an instance of Subscription from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Subscription.parse_obj(obj)

        _obj = Subscription.parse_obj({
            "object": obj.get("object"),
            "id": obj.get("id"),
            "current_period": SubscriptionCurrentPeriod.from_dict(obj.get("currentPeriod")) if obj.get("currentPeriod") is not None else None,
            "phone_number": obj.get("phoneNumber"),
            "plan": Plan.from_dict(obj.get("plan")) if obj.get("plan") is not None else None,
            "porting": SubscriptionPorting.from_dict(obj.get("porting")) if obj.get("porting") is not None else None,
            "sim": SubscriptionSim.from_dict(obj.get("sim")) if obj.get("sim") is not None else None,
            "status": obj.get("status"),
            "user": User.from_dict(obj.get("user")) if obj.get("user") is not None else None,
            "activated_at": obj.get("activatedAt"),
            "canceled_at": obj.get("canceledAt"),
            "created_at": obj.get("createdAt"),
            "ended_at": obj.get("endedAt"),
            "first_usage_at": obj.get("firstUsageAt")
        })
        return _obj

