# coding: utf-8

"""
    Gigs Core API

    API to manage voice & data plans for smartphones, wearables and IoT in 200+ countries.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@gigs.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Optional
from pydantic import BaseModel, Field

class SubscriptionChangesCreateRequest(BaseModel):
    """
    SubscriptionChangesCreateRequest
    """
    plan: Optional[Any] = Field(..., description="Unique identifier of the target plan, to which the subscription should be changed.")
    subscription: Optional[Any] = Field(..., description="Unique identifier of the subscription to be changed.")
    __properties = ["plan", "subscription"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SubscriptionChangesCreateRequest:
        """Create an instance of SubscriptionChangesCreateRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if plan (nullable) is None
        # and __fields_set__ contains the field
        if self.plan is None and "plan" in self.__fields_set__:
            _dict['plan'] = None

        # set to None if subscription (nullable) is None
        # and __fields_set__ contains the field
        if self.subscription is None and "subscription" in self.__fields_set__:
            _dict['subscription'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SubscriptionChangesCreateRequest:
        """Create an instance of SubscriptionChangesCreateRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SubscriptionChangesCreateRequest.parse_obj(obj)

        _obj = SubscriptionChangesCreateRequest.parse_obj({
            "plan": obj.get("plan"),
            "subscription": obj.get("subscription")
        })
        return _obj

