# coding: utf-8

"""
    Gigs Core API

    API to manage voice & data plans for smartphones, wearables and IoT in 200+ countries.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@gigs.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Optional
from pydantic import BaseModel, Field

class UserAddress(BaseModel):
    """
    UserAddress
    """
    object: Optional[Any] = Field(..., description="Type of object is always `userAddress`.")
    id: Optional[Any] = Field(..., description="Unique identifier for the given address.")
    city: Optional[Any] = Field(..., description="The city/municipality of the given street address.")
    country: Optional[Any] = Field(..., description="The ISO 3166-1 alpha-2 country code for the given address.")
    line1: Optional[Any] = Field(..., description="The first line of the given street address, e.g. street and house number.")
    line2: Optional[Any] = Field(..., description="The second line of the given street address, e.g. Apartment number.")
    postal_code: Optional[Any] = Field(..., alias="postalCode", description="The postal code of the given street address.")
    state: Optional[Any] = Field(..., description="The state/province/region of the given street address.")
    user: Optional[Any] = Field(..., description="Unique identifier for the given address user.")
    created_at: Optional[Any] = Field(..., alias="createdAt", description="The time the address was created.")
    __properties = ["object", "id", "city", "country", "line1", "line2", "postalCode", "state", "user", "createdAt"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UserAddress:
        """Create an instance of UserAddress from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if object (nullable) is None
        # and __fields_set__ contains the field
        if self.object is None and "object" in self.__fields_set__:
            _dict['object'] = None

        # set to None if id (nullable) is None
        # and __fields_set__ contains the field
        if self.id is None and "id" in self.__fields_set__:
            _dict['id'] = None

        # set to None if city (nullable) is None
        # and __fields_set__ contains the field
        if self.city is None and "city" in self.__fields_set__:
            _dict['city'] = None

        # set to None if country (nullable) is None
        # and __fields_set__ contains the field
        if self.country is None and "country" in self.__fields_set__:
            _dict['country'] = None

        # set to None if line1 (nullable) is None
        # and __fields_set__ contains the field
        if self.line1 is None and "line1" in self.__fields_set__:
            _dict['line1'] = None

        # set to None if line2 (nullable) is None
        # and __fields_set__ contains the field
        if self.line2 is None and "line2" in self.__fields_set__:
            _dict['line2'] = None

        # set to None if postal_code (nullable) is None
        # and __fields_set__ contains the field
        if self.postal_code is None and "postal_code" in self.__fields_set__:
            _dict['postalCode'] = None

        # set to None if state (nullable) is None
        # and __fields_set__ contains the field
        if self.state is None and "state" in self.__fields_set__:
            _dict['state'] = None

        # set to None if user (nullable) is None
        # and __fields_set__ contains the field
        if self.user is None and "user" in self.__fields_set__:
            _dict['user'] = None

        # set to None if created_at (nullable) is None
        # and __fields_set__ contains the field
        if self.created_at is None and "created_at" in self.__fields_set__:
            _dict['createdAt'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UserAddress:
        """Create an instance of UserAddress from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UserAddress.parse_obj(obj)

        _obj = UserAddress.parse_obj({
            "object": obj.get("object"),
            "id": obj.get("id"),
            "city": obj.get("city"),
            "country": obj.get("country"),
            "line1": obj.get("line1"),
            "line2": obj.get("line2"),
            "postal_code": obj.get("postalCode"),
            "state": obj.get("state"),
            "user": obj.get("user"),
            "created_at": obj.get("createdAt")
        })
        return _obj

